﻿
using System;

namespace WindowsFormsApplication1
{
    public delegate double function(double value);

    class TLayer
    {
        public int featuresIn;
        public int featuresOut;
        public double[] x;
        public double[] o;
        public double[,] w;
        public double[] offs;
        public double[] deltaOffs;
        public double[] gradient;
        public double[,] deltaW;
      
        public function Act;
        public function dAct;

        public TLayer(int iFeaturesIn, int iFeaturesOut)
        {
            int j, k;
            featuresIn = iFeaturesIn;
            featuresOut = iFeaturesOut;
            w = new double[featuresIn, featuresOut];
            o = new double[featuresOut];
            offs = new double[featuresOut];
            deltaOffs = new double[featuresOut];
            deltaW = new double[featuresIn, featuresOut];
            x = new double[featuresOut];
            gradient = new double[featuresOut];
            for (j = 0; j < featuresOut; j++)
            {
                offs[j] = 0;
                deltaOffs[j] = 0;
                for (k = 0; k < featuresIn; k++)
                {
                    w[k, j] = -0.5 + 0.5 * k;
                    deltaW[k, j] = 0;
                }
            }
            Act = Sigmoid;
            dAct = dSigmoid;
        }

        public double Sigmoid(double x)
        {
            return 1.0 / (1.0 + Math.Exp(- 0.5 * x));
        }

        public double dSigmoid(double x)
        {
            return  0.5 * x * (1 - x);
        }

        public double Neutral(double x)
        {
            return x;
        }

        public double dNeutral(double x)
        {
            return 1;
        }
    }
}
